/*
 * Copyright 2004-2006 Robbie.JP
 */
package robbie.dao.x;

import java.io.Serializable;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.jdom.Element;

import robbie.util.CollectionsUtil;
import robbie.util.InstanceFactory;
import robbie.util.XmlResource;

/**
 * XDAOFactoryNXB<p>
 * w肳ꂽt@CɊÂāADAOCX^X𐶐܂B
 * @author Tadahiro Murakami
 */
public class XDaoFactory implements Serializable {
    
    private static final long serialVersionUID = -7266751084337417590L;

    private static final Log LOG = LogFactory.getLog(XDaoFactory.class);
    
    /** XMLt@CǗNX */
    protected XmlResource xmlResource = null;
    
    /** XQueryFactoryClass */
    protected String xQueryFactoryClassName = XQueryFactory.class.getName();
    
    /** XDbResourceFactoryClass */
    protected String xDBResourceFactoryClassName = XDbResourceFactory.class.getName();
    
    /** XQueryFactorỹCX^X */
    protected XQueryFactory queryFactory = null;
    
    /** XDBResourceFactorỹCX^X */
    protected XDbResourceFactory resourceFactory = null;
    
    /** DAÕNXǗMap */
    protected Map daoNameMap = null;
    
    /** DAOƗpDbResource̊֘AǗMap */
    protected Map daoResRefMap = null;
    
    /**
     * ftHgRXgN^B<>
     */
    private XDaoFactory() {
        // ȂB
    }

    /**
     * NXpX܂̓t@C琧t@CǍݏȂ܂B<p>
     * filenaméAt@Cłt@CPATHłw肷邱Ƃ\łB
     * At@Cw肷ꍇɂ́Ãt@CclasspathɔzuĂ
     * Kv܂B<br> 
     * <br>
     * ܂AJARt@CŌꍇɂ́A[h͍s܂B
     * ʏ̃fBNgŌꍇɂ̓t@CX^vmF
     * [hs܂B
     * @param filename t@C
     * @param isValidate XML̃[hɌ؂s
     */
    public XDaoFactory(String filename, boolean isValidate) {
        this.xmlResource = new XmlResource(filename, isValidate);
        configure();
    }
    
    /**
     * NXpX܂̓t@C琧t@CǍݏȂ܂B<p>
     * @param filename t@C
     */
    public XDaoFactory(String filename) {
        this.xmlResource = new XmlResource(filename, false);
        configure();
    }
    
    /**
     * DAOCX^X擾B<p>
     * VKDAO쐬Ƃ́A̎̍ŐV̐XML̓e
     * fB
     * @param id DAOID
     * @param loader 쐬CX^XClassLoader
     * @return xDAOCX^X
     */
    public XDao createDaoInstance(String id, ClassLoader loader) {
        
        configureIfNeeded();
        if (!daoNameMap.containsKey(id)) {
            throw new XDaoException("id=[" + id + "]QueryXMLɒ`Ă܂.");
        }
        Object obj = InstanceFactory.createInstance((String)daoNameMap.get(id), loader);
        XDao dao = (XDao)obj;
        dao.setQueryFactory(queryFactory);
        dao.setResource(resourceFactory.getDbResource((String)daoResRefMap.get(id)));
        dao.configure();
        return dao;
    }
    
    /**
     * DAOCX^X擾B<p>
     * VKDAO쐬Ƃ́A̎̍ŐV̐XML̓e
     * fB
     * @param id DAOID
     * @return xDAOCX^X
     */
    public XDao createDaoInstance(String id) {
        return createDaoInstance(id, null);
    }
    
    public String toString() {
        return " resourceFactory=[" + this.resourceFactory + "]"
                + " queryFactory=[" + this.queryFactory + "]"
                + " daoNameMap=[" + this.daoNameMap + "]"
                + " daoResRefMap=[" + this.daoResRefMap + "]";
    }
    
    /**
     * SĂ̐XV܂B<p>
     * ͓̏Ă܂B
     */
    protected void configure() {
        Element root = this.xmlResource.getRootElement();
        
        // ver1.1܂ł͓Ă܂łA
        // ver1.2瓯܂B
        // A̓Sł͂܂B
        if (resourceFactory != null) {
            synchronized(resourceFactory) {
                configureResourceFactory(root);
                conifgureDAOMap(root);
                configureQueryFactory(root);
            }
        } else {
            configureResourceFactory(root);
            conifgureDAOMap(root);
            configureQueryFactory(root);
        }
    }
    
    /**
     * SĂ̐XV܂B<p>
     * ͓̏Ă܂B
     */
    protected void configureIfNeeded() {
        if (this.xmlResource.isUpdated()) {
            configure();
        }
    }
    
    /** 
     * XDbResourceFactoryNX쐬܂B<p>
     * @param root XMLrootElement
     */
    protected void configureResourceFactory(Element root) {
        
        if (LOG.isDebugEnabled()) {
            LOG.debug(
                "configureResourceFactory(): XDbResourceFactorỹNX=" + 
                this.xDBResourceFactoryClassName);
        }
        
        XDbResourceFactory factory = 
            (XDbResourceFactory)InstanceFactory.createInstance(this.xDBResourceFactoryClassName);
        factory.configure(root.getChild("resource-list"));
        this.resourceFactory = factory;
    }
    
    /**
     * DAÕNXƑΏۃ\[XMapt@C[hB<p>
     * @param root XMLrootElement
     */
    protected void conifgureDAOMap(Element root) {
        
        Element daoList = root.getChild("dao-list");
        if (daoList == null) {
            throw new XDaoException("dao-listvfNULLł.");
        }
        List list = daoList.getChildren("dao");
        if (list != null && list.size() > 0) {
            Map nameMap = CollectionsUtil.createMap();
            Map refMap = CollectionsUtil.createMap();
            for (Iterator it=list.iterator(); it.hasNext(); ) {
                Element ele = (Element)it.next();
                String id = ele.getAttributeValue("id");
                if (id == null) {
                    throw new XDaoException("daovfidNULLł.");
                }
                String calssName = null;;
                String refResoauce = null;
                try {
                    calssName = ele.getChild("class").getText();
                    refResoauce = ele.getChild("resource-ref").getText();
                } catch(Exception ex) {
                    throw new XDaoException("class-namevfA܂resource-refvfnullł.", ex); 
                }
                if (nameMap.containsKey(id) && LOG.isDebugEnabled()) {
                    LOG.warn("x! DAOid=[" + id + "]͊ɒ`݂܂. Vŏ㏑܂.");
                }
                nameMap.put(id, calssName);
                refMap.put(id, refResoauce);
            }
            this.daoNameMap = nameMap;
            this.daoResRefMap = refMap;
            
            if (LOG.isDebugEnabled()) {
                LOG.debug("XDao Name " + this.daoNameMap);
                LOG.debug("XDao Reource-ref " + this.daoResRefMap);
            }
        }
    }
    
    /**
     * XQueryFactoryNX쐬܂B<p>
     * @param root XMLrootElement
     */
    protected void configureQueryFactory(Element root) {
        
        if (LOG.isDebugEnabled()) {
            LOG.debug(
                "configureQueryFactory(): XQueryFactorỹNX=" + 
                this.xQueryFactoryClassName);
        }
        
        XQueryFactory factory = 
            (XQueryFactory)InstanceFactory.createInstance(this.xQueryFactoryClassName);
        factory.configure(root.getChild("query-list"));
        this.queryFactory = factory;
    }
}
