/*
 * Copyright 2004-2007 Robbie.JP
 */
package robbie.util;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.jdom.Element;


/**
 * Xmlt@C擾RootElement̃\[XǗs܂B<p>
 * @since 1.4
 * @author Tadahiro Murakami
 */
public class XmlResource implements Serializable {

    private static final long serialVersionUID = 6287138104725067632L;

    private static final Log LOG = LogFactory.getLog(XmlResource.class);
    
    /** XML̃[hɌ؂sBftHg͍sȂ */
    protected boolean isValidate = false;
    
   /** t@CFilepath */
    protected String filepath = null;
    
    /** t@CFilename */
    protected String filename = null;
    
    // init inputStream 1970/1/1 00:00:00:000
    /** t@C̍XV */
    protected long lastModifiedTimestamp = 0;
    
    /** ǗXML̃[gvf */
    protected Element ele = null;
    
    /**
     * Xmlt@C̏[hs܂B<p>
     */
    public XmlResource(String filename, boolean isValidate) {
        super();
        this.filename = filename;
        this.isValidate = isValidate;
        this.ele = loadRootElemet(getInputStream(filename), this.isValidate);
    }
    
    /**
     * Xmlt@C̏[hs܂B<p>
     */
    public XmlResource(String filename) {
        this(filename, false);
    }
    
    /**
     * InputStream琧XMLElementǂݍ݂܂B<p>
     * @param inputStream RootElementǂݍނ߂InputStream
     * @return rootElement
     */
    public static Element loadRootElemet(InputStream inputStream, boolean isValidate) {
        try {
            return JdomXmlLoader.load(inputStream, isValidate);
        } catch(Exception ex) {
            throw new XmlResourceException("XMLt@C[hɗOo܂.", ex);
        }
    }
    
    public boolean isUpdated() {
        if (filepath == null) {
            return false;
        }
        long nowLastModifiedTimestamp = (new File(filepath)).lastModified();
        if (nowLastModifiedTimestamp > lastModifiedTimestamp) {
            if (LOG.isDebugEnabled()) {
                LOG.debug("reload config file." + 
                    " filepath=" + this.filepath +
                    " ܂ł̃^CX^v = " + new Date(lastModifiedTimestamp) + 
                    " XVꂽ^CX^v = " + new Date(nowLastModifiedTimestamp) +
                    " t@C[hKv܂.");
            }
            return true;
        }
        return false;
    }
    
    public Element getRootElement() {
        if (isUpdated()) {
            this.ele = loadRootElemet(getInputStream(this.filename), this.isValidate);
        }
        return ele;
    }

    protected InputStream getInputStream(String filename) {
        if (filename == null || filename.length() == 0) {
            throw new IllegalArgumentException("p[^filenameNULL0ł");
        }
        
        try {
            InputStream is = null;
            String filepath = null;
            ClassLoader loader = Thread.currentThread().getContextClassLoader();
            URL url = loader.getResource(filename);
            
            if (url != null) {
                filepath = url.getFile();
                if (LOG.isDebugEnabled()) {
                    LOG.debug(
                        " CLASSPATHURLCX^X쐬ł܂. filename=" + filename + 
                        " URLCX^XgetFile()gpFileInputStream쐬܂. filepath=" + filepath);
                }
                try {
                    is = new FileInputStream(filepath);
                } catch(FileNotFoundException ex) {
                    
                    // t@CVXeȊȌꏊ(JARt@CȂ)Ńt@Cꍇ
                    if (LOG.isDebugEnabled()) {
                        LOG.debug(
                            " FileInputStream̍쐬Ɏs܂. filepath=" + filepath + 
                            " URL#openStream()InputStream쐬ďs܂. " +
                            " Ȁꍇt@CX^vmFĒ`̃[h͍s܂B.");
                    }
                    is = url.openStream();
                }
            } else {
                filepath = filename;
                if (LOG.isDebugEnabled()) {
                    LOG.debug(
                        " CLASSPATH܂t@C܂ł. filename=" + filename + 
                        " t@CPATHƂFileInputStream쐬܂.");
                }
                is = new FileInputStream(filename);
            }
            
            // [hp̃t@CpXƃ^CX^vۑ
            if (is instanceof FileInputStream) {
                this.filepath = filepath;
                this.lastModifiedTimestamp = (new File(filepath)).lastModified();
            }
            
            return new BufferedInputStream(is);
            
        } catch(FileNotFoundException ex) {
            LOG.error("t@C܂ł. filepath = "+ filename, ex);
            throw new XmlResourceException("file not found. filepath = "+ filename, ex);
        } catch(IOException ex) {
            LOG.error("t@C܂ł. filepath = "+ filename, ex);
            throw new XmlResourceException("file not found. filepath = "+ filename, ex);
        }
    }
}
